// Global Vars...
var gXMMContextMenu_Edit = "XMMDwExMenu_ContextMenuEdit";
var gXMMContextMenu_PhotoProcess = "XMMDwExMenu_ContextMenuPhotoProcess";
var gbXMMShowObjectsFloater = false;
var gbXMMShowPropertiesFloater = false;
var g_xmmOuterPattern = /\<script[ \t]+menumaker(.*?)\<\/script[ \t]*\>/i;
var g_xmmInnerPattern = /^[ \t]*\>(.*)\/\*.*img[ \t]+src[ \t]*=[ \t]*\"([^\"]*)\".*/i;


// API functions...
function canInspectSelection()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return false; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return false; }
	if (!selNode.getAttribute)  { return false; }

	var selAttr = selNode.getAttribute("Editor");
	if (selAttr)
	{
		var bCanInspect = (null != selAttr.match(/menumaker/i));
		
		if (bCanInspect)
		{
			selAttr = selNode.getAttribute("ModuleId");
			bCanInspect = (selAttr && (selAttr != ""));
		}

		return bCanInspect;
	}

	// This should check for the translated version now...
	var translatorClass = selNode.getAttribute("translatorClass");
	if (!translatorClass || (translatorClass != "XMMDwExTrans")) { return false; }

	var lockType = selNode.getAttribute("type");
	if (!lockType || (lockType != "XMMDwExTrans")) { return false; }
	
	var orig = selNode.getAttribute("orig");
	if (!orig) { return false; }
	
	orig = unescape(orig);
	var bCanInspect = (null != orig.match(/\<script[ \t]+menumaker/i));

	
	return bCanInspect;
}

// Actually do something in the Property Inspector...
function inspectSelection()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	var selObj = docDOM.getSelectedNode();
	if (!selObj) { return; }

	var selHTML = selObj.innerHTML;

	// Find the image name...
	var imageSrc = selHTML.match(/img[ \t]+src=\"([^\"]*)\"/i);
	if (imageSrc == null) { return; }
	imageSrc = imageSrc[1];

	var imgSrc = imageSrc.replace(/\\/g, "/");
	var index = imgSrc.lastIndexOf("/");

	if (index != -1) { imgSrc = unescape(imgSrc.substr(index+1)); }
	var piObject = findObject("WSPI File");
	if (piObject  && imgSrc) { piObject.innerHTML = imgSrc.substr(0, 35); }

	// Find the project string within the moduleID...
	var projectName = selHTML.match(/moduleid=\"\'*([^\"]*) \(Project\)\\[^\"]*\"/i);
	if (!projectName) { projectName = "None"; }
	else
	{
		projectName = projectName[1];
		projectName = unescape(projectName);
	}
	
	piObject = findObject("WSPI Project");
	if (piObject && projectName) { piObject.innerHTML = projectName.substr(0, 35); }
	
	// Set the alignment button/indicator as appropriate...
	switch (dw.getDocumentDOM().getTextAlignment())
	{
		case 'left' :
			wsSetLeftAlign();
			break;

		case 'center' :
			wsSetCenterAlign();
			break;

		case 'right' :
			wsSetRightAlign();
			break;

		default :
			wsSetNoAlign();
			break;
	}

	/*// Set the 'Link' input field...
	piObject = findObject("WSPI Link Edit");
	if (piObject) { piObject.value = unescape(getNodeAnchorAttribute(selObj, "href")); }

	// Set the 'Alt' input field...
	piObject = findObject("WSPI Alt Edit");
	if (piObject) { piObject.value = getNodeAlt(selObj); }

	// Set the 'Target' input field...
	piObject = findObject("WSPI Target Edit");
	if (piObject) { piObject.value = getNodeAnchorAttribute(selObj, "target"); }*/

	// Get the image dimensions and put them into our array...
	var imageDimensions = menuMakerGetImageDimensions(imageSrc);

	// Set the 'Width' field...
	piObject = findObject("WSPI Width");
	if (piObject) { piObject.innerHTML = imageDimensions[0]; }

	// Set the 'Height' field...
	piObject = findObject("WSPI Height");
	if (piObject) { piObject.innerHTML = imageDimensions[1]; }
}

// User has asked to insert a new object...
function objectTag()
{
	menuMakerNew(-1);
	return("");
}

// The menu items for Button, Logo, etc pass us an argument, which we should then pass on to the menuMakerNew() function...
function receiveArguments()
{
	if (arguments.length != 1) return;
	var graphicType = arguments[0];

	// The following graphic types will be given when the context menu obtions are selected (PhotoProcess/Edit)
	if (graphicType == gXMMContextMenu_Edit) { MenuMakerEdit(); return; }

	// If we should perform an update, then do so...
	if (graphicType == 'U') { UpdateMenuMaker(); return; }

	// If none of the above was desired, then make a new graphic with the given type...
	menuMakerNew(graphicType);
}

// API function - puts the 'Help' icon on our inspector and calls the correct help function...
function displayHelp()
{
	showHelp();
}

//function markupSnippet(orig, version, content)
function markupSnippet(orig, content)
{
	if (!content) { return orig; }

	matchArray = content.match(g_xmmInnerPattern);

	if (null != matchArray && 3 == matchArray.length)
	{
		return "<MM:BeginLock translatorClass=\"XMMDwExTrans\" type=\"XMMDwExTrans\" orig=\"" + escape(orig) + "\">\n<script menumaker>" + matchArray[1] + "<\/script><noscript><br><img src=\"" + escape(matchArray[2]) + "\"><br><\/noscript>\n<MM:EndLock>";
	}

	return orig;
}

function translateMarkup(docNameStr, siteRootStr, inStr)
{
	var matchArray = null;
	var output = "";

	for(;;)
	{
		matchArray = inStr.match(g_xmmOuterPattern);
		if (null == matchArray)
		{
			output += inStr;
			break;
		}
		output += RegExp.leftContext;
		inStr = RegExp.rightContext;

		//output += markupSnippet(matchArray[0], matchArray[1], matchArray[2]);
		output += markupSnippet(matchArray[0], matchArray[1]);
	}
	while (null != matchArray);

	return output;
}

function getTranslatorInfo()
{
	var returnArray = new Array(10);

	returnArray[0] = "XMMDwExTrans";		// The translatorClass
	returnArray[1] = "Menu Maker Translator";	// The title
	returnArray[2] = "2";			// The number of extensions
	returnArray[3] = "html";			// The second extension
	returnArray[4] = "htm";			// The third extension
	returnArray[5] = "2";			// The number of expressions
	returnArray[6] = "<script menumaker";	// Expression for PI and insert
	returnArray[7] = "<script menumaker";	// Expression for PI and insert
	returnArray[8] = "allFiles";			// Default translation on for all files
	returnArray[9] = "50";			// priority order to apply translator

	return returnArray;
}


// MenuMaker-specific functions...
// In the functions below, the menumaker js dll is executed and the return value ('result') is an array with the following components
//	result[0]	Bool	Success
//	result[1]	String	ModuleID
//	result[2]	String	LiveHTML
//	result[3]	String	PreviewHTML


// Edit the current selection with MenuMaker
function MenuMakerEdit()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return; }

	var modID = selNode.innerHTML.match(/moduleid[ \t]*=[ \t]*(\"[^\"]*\")/i);
	if (!modID || !modID[1]) { return; }
	modID = modID[1];
	
	var bThumbnail = false;
	
	// Hide the floaters which would allow further use of the menumaker integration components whilst editing...
	showFloaters(false);

	// Launch MenuMaker to edit the image...
	var result = XMMDwExJs.Edit(modID, getBackgroundColour(), -1, getExportPath());
	if (result[0] != true)
	{
		// Display the floaters that we have hidden...
		showFloaters(true);
		return;
	}

	// Remove the single and double quotes...
	modID = result[1].replace(/\'/g, "");
	modID = modID.replace(/\"/g, "");

	var strHTML = result[2] ? result[2] : "";
	if ((strHTML.length > 1) && (strHTML.charAt(0) == "\"")) { strHTML = strHTML.substr(1); }
	if ((strHTML.length > 1) && (strHTML.charAt(strHTML.length - 1) == "\"")) { strHTML = strHTML.substr(0, strHTML.length - 1); }
	if (modID != "") { strHTML = modifyMenuMakerHTML(strHTML, modID); }

	var strOnClick = result[2].match(/[ \t]onClick=\"([^\"]*)\"/i);
	if (strOnClick) { strOnClick = strOnClick[1]; } else { strOnClick = ""; }

	var strHref = result[2].match(/[ \t]href=\"([^\"]*)\"/i);
	if (strHref) { strHref = strHref[1]; } else { strHref = ""; }

	var strAlt = result[2].match(/[ \t]alt=\"([^\"]*)\"/i);
	if (strAlt)
	{
		strAlt = strAlt[1];
		strAlt = strAlt.replace(/&gt;/g, ">");
		strAlt = strAlt.replace(/&lt;/g, "<");
		strAlt = strAlt.replace(/&#39;/g, "\'");
		strAlt = strAlt.replace(/&#34;/g, "\"");
		strAlt = strAlt.replace(/&amp;/g, "&");
	}
	else { strAlt = ""; }

	// If we are replacing a thumbnail, then replace it's onClick, href and alt text...
	if (bThumbnail)
	{
		replaceNodeAnchorAttribute(selNode, "onClick", strOnClick);
		replaceNodeAnchorAttribute(selNode, "href", strHref);
		if (strAlt != "") { selNode.setAttribute("alt", strAlt); }
	}

	if (!bThumbnail && (strOnClick != ""))
	{
		selNode.outerHTML = strHTML;
	}
	else
	// If we are replacing a non-translated object with another, then do the special case...
	if ((selNode.outerHTML.search(/\<script/gi) == -1) && (result[2].search(/\<script/gi) == -1)
		&& bThumbnail && (strOnClick != ""))
	{
		// If we are replacing a non-thumbnail object with a thumbnail, then we should replace it wholesale...
		var imgSrc = result[2].match(/\<img[ \t]+.*\bsrc[ \t]*=[ \t]*\"([^\"]*)\"/i);
		if (imgSrc) { imgSrc = imgSrc[1]; } else { imgSrc = ""; }

		// Replace the module ID unless, we are inserting a photo - in which case remove it and the editor attribute
		var selectedNode = selNode.outerHTML;
		if ((modID != "") && (modID.toLowerCase() != "thumbnail"))
		{
			selectedNode = replaceModuleID(modID, selectedNode);
			selectedNode = replaceImgSrc(imgSrc, selectedNode);
		}

		selectedNode = removeWidthAndHeight(selectedNode);
		if (selectedNode && (selectedNode != "")) { selNode.outerHTML = selectedNode; }
	}
	else
	{
		// Get the currently selected node and update the html...
		var offsets = docDOM.getSelection();
		var docSrc = docDOM.documentElement.outerHTML;
		var beforeSelStr = docSrc.substring(0, offsets[0]);
		var afterSelStr = docSrc.substring(offsets[1]);

		// Assemble the new contents of the document.
		docSrc = beforeSelStr + strHTML + afterSelStr;
		docDOM.documentElement.outerHTML = docSrc;
		docDOM.setSelection(offsets[0], offsets[1]);
	}

	// Force translator to execute...
	forceTranslate();

	// Display the floaters that we have hidden...
	showFloaters(true);
}

// Create a new object with MenuMaker
function menuMakerNew(graphicType)
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	// Hide the floaters which would allow further use of the menumaker integration components whilst editing...
	showFloaters(false);

	// Launch MenuMaker to produce a new graphic with the current options...
	var result = XMMDwExJs.Edit(getExportPath(), getBackgroundColour(), graphicType, getExportPath());
	if (result[0] != true)
	{
		// Display the floaters that we have hidden...
		showFloaters(true);
		return;
	}

	// Remove the single and double quotes...
	var modID = result[1].replace(/\'/g, "");
	modID = modID.replace(/\"/g, "");

	var strHTML = result[2];
	if ((strHTML.length > 1) && (strHTML.charAt(0) == "\"")) { strHTML = strHTML.substr(1); }
	if ((strHTML.length > 1) && (strHTML.charAt(strHTML.length - 1) == "\"")) { strHTML = strHTML.substr(0, strHTML.length - 1); }
	if (modID != "") { strHTML = modifyMenuMakerHTML(strHTML, modID); }
	
	// Insert the HTML Into the document...
	docDOM.insertHTML(strHTML, false);
	
	// Force translator to execute...
	forceTranslate();

	// Display the floaters that we have hidden...
	showFloaters(true);
}


// Replace the module ID parameter with a new one!
function replaceModuleID(modID, strHTML)
{
	if (!modID || !strHTML) { return ""; }
	return strHTML.replace(/(\<img[ \t]+.*\bmoduleid[ \t]*=[ \t]*\")[^\"]*(\")/gi, function (orig, beforeModID, afterModID) { return beforeModID + modID + afterModID; } );
}

// Replace the image source parameter...
function replaceImgSrc(imgSrc, strHTML)
{
	if (!imgSrc || !strHTML) { return ""; }
	return strHTML.replace(/(\<img[ \t]+.*\bsrc[ \t]*=[ \t]*\")[^\"]*(\")/gi, function (orig, beforeImage, afterImage) { return beforeImage + imgSrc + afterImage; } );
}

// Remove the width and height attributes...
function removeWidthAndHeight(strHTML)
{
	if (!strHTML) { return ""; }

	// Remove the width and height...
	strHTML = strHTML.replace(/(\<img[ \t]+.*)\bwidth[ \t]*=[ \t]*\"[^\"]*\"/gi, function (orig, beforeWidth) { return beforeWidth; } );
	strHTML = strHTML.replace(/(\<img[ \t]+.*)\bheight[ \t]*=[ \t]*\"[^\"]*\"/gi, function (orig, beforeHeight) { return beforeHeight; } );
	return strHTML;
}

// Update MenuMaker
function UpdateMenuMaker()
{
	// Launch MenuMaker in Update mode...
	var result = XMMDwExJs.Update();
}

// Find the current document's export path - MenuMaker will use this as the default directory to save images to...
function getExportPath()
{
	var path = dreamweaver.getDocumentPath("document");

	var index = path.lastIndexOf('/');
	if (index != -1) { path = path.substring(0, index); }

	return path;
}

// Get the current document's background colour...
function getBackgroundColour()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return "NoColor"; }

	var bgCol = docDOM.body.bgcolor;
	if (!bgCol) { bgCol = "NoColor"; }
	return bgCol;
}

// Get the dll to show the MenuMaker help on the appropriate page...
function showHelp()
{
	XMMDwExJs.ShowHelp();
}

// Get the dll to show the information for itself (file version etc)...
function moduleInfo()
{
	XMMDwExJs.ModuleInfo();
}

// Function to force a translation - DW3 doesn't appear to run translators as often as DW4...
function forceTranslate()
{
	dreamweaver.getDocumentDOM().documentElement.outerHTML = translateMarkup("", "", dreamweaver.getDocumentDOM().documentElement.outerHTML);
}

// Change MenuMaker produced HTML into something that DW can successfully display...
function modifyMenuMakerHTML(html, moduleid)
{
	// Thumbnail HTML should not be modified by this function...
	if (moduleid.toLowerCase() == 'thumbnail') { return html; }
	
	// Sample NavBar HTML generated by MenuMaker... We need to convert this into something Dreaweaver will display!
	// menumaker may return the following two types of script for us to modify. The first is used for menus, the second for NavBars.
	// html = "<script menumaker>document.write('<scr'+'ipt src=\"xaramenu.js\">'+'<\/scr'+'ipt>');document.write('<scr'+'ipt src=\"images/flavour.js\">'+'<\/scr'+'ipt>');</script><noscript><img src=\"images/flavour.gif\" editor=\"MenuMaker\"></noscript>";
	// html = "<script menumaker src=\"images/flavour.js\"></script><noscript><img src=\"images/flavour.gif\" editor=\"MenuMaker\"></noscript>";

	var wsPattern = /\<script[ \t]+menumaker(.*?)\<\/script\>\<noscript\>(.*?)\<\/noscript\>/i;
	var matchArray = null;

	matchArray = html.match(wsPattern);

	if (null == matchArray || 3 != matchArray.length)
	{
		return html.replace(/img[ \t]+src=\"[^\"]*\"[ \t]+editor=\"menumaker\"/i, function(orig) { return orig + " moduleid=\"" + moduleid + "\""; });
	}

	var wsScript		= matchArray[1];
	var wsNoScript		= matchArray[2];

	var wsSrcMatchArray	= wsScript.match(/^[ \t]*src[ \t]*=[ \t]*\"([^\"]*)\"[ \t]*\>$/i);
	var output		= "<script menumaker";

	if (null != wsSrcMatchArray)
	{
		output += ">document.write('<scr' + 'ipt src=\"" + wsSrcMatchArray[1] + "\">'+'</scr'+'ipt>');";
	}
	else
	{
		output += wsScript;
	}

	var wsPrevMatchArray = wsNoScript.match(/^\<img[ \t]*src[ \t]*=[ \t]*\"([^\"]*)\"/i);

	if (null != wsPrevMatchArray)
	{
		output += "/*img src=\"" + wsPrevMatchArray[1] + "\" moduleid=\"" + moduleid + "\"*/";
	}

	output += "</script>";
	return output;
}


// Property Inspector Alignment Button/Indicator Functions...
function wsPerformAlignment(desiredAlignment)
{
	var bVersionThree = false;
	if (dw.appVersion)
	{
		var re = /^\d+/;
		var appversion = dw.appVersion.match(re);
		if (appversion && (appversion == 3)) { bVersionThree = true; }
	}

	// If we're running on Dreamweaver3, we can set the alignment anytime, if we're in 4 then we can only set it when the
	// focus is on the main preview editor - the 'document'
	if (bVersionThree || (dw.getFocus(false) == 'document'))
	{
		// Update the alignment as requested...
		dw.getDocumentDOM().setTextAlignment(desiredAlignment);

		// Update the property inspector to reflect this...
		switch (desiredAlignment)
		{
			case 'left' :
				wsSetLeftAlign();
				break;

			case 'center' :
				wsSetCenterAlign();
				break;

			case 'right' :
				wsSetRightAlign();
				break;

			default :
				wsSetNoAlign();
				break;
		}
	}
	else
	{
		alert("Object alignment cannot be adjusted at this time.\nPlease select the object in the document view.");
	}
}


function wsSetNoAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetLeftAlign()
{
	setAlignObjectSelected("WSPI Align Left", true);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetCenterAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", true);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetRightAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", true);
}

function isAlignObjectSelected(alignObject)
{
	var imgSrc = alignObject.innerHTML.match(/img *src=\"([^\"]*)\"/i)[1];
	return (-1 != imgSrc.lastIndexOf("_sel.gif"));
}

function setAlignObjectSelected(alignObjectId, bDesiredSelected)
{
	var alignObject = findObject(alignObjectId);
	if (!alignObject) { return; }

	var bSelected = isAlignObjectSelected(alignObject);
	if (bDesiredSelected && !bSelected) { alignObject.innerHTML = alignObject.innerHTML.replace(/\.gif\"/i, "_sel.gif\""); }
	if (!bDesiredSelected && bSelected) { alignObject.innerHTML = alignObject.innerHTML.replace(/_sel\.gif\"/i, ".gif\""); }
}

function getNodeAlt(currentNode)
{
	if (!currentNode) { return ""; }

	var currentAlt = currentNode.getAttribute("alt");
	if (!currentAlt) { currentAlt = ""; }
	return currentAlt;
}

// Generic functions to recursively search up the tree from the specified node looking for an anchor tag which is the parent of the current node
// Once found, the specified attribute is modified to the new value.
function replaceNodeAnchorAttribute(currentNode, anchorAttribute, newValue)
{
	if (!currentNode) { return false; }

	var currentTag = currentNode.tagName;
	if (!currentTag) { return false; }

	if (currentTag == "A")
	{
		if (currentNode.getAttribute(anchorAttribute) != newValue) { currentNode.setAttribute(anchorAttribute, newValue); }
		return true;
	}
	else
	{
		return replaceNodeAnchorAttribute(currentNode.parentNode, anchorAttribute, newValue);
	}
}

function getNodeAnchorAttribute(currentNode, anchorAttribute)
{
	if (!currentNode) { return ""; }

	var currentTag = currentNode.tagName;
	if (!currentTag) { return ""; }

	if (currentTag == "A")
	{
		var attributeValue = currentNode.getAttribute(anchorAttribute);
		if (!attributeValue || (attributeValue == "undefined")) { attributeValue = ""; }
		return attributeValue;
	}
	else
	{
		return getNodeAnchorAttribute(currentNode.parentNode, anchorAttribute);
	}
}

function urlToPathname(strUrl)
{
	if (typeof(strUrl) == "undefined")
		return "";
	strUrl = strUrl.replace(/\|/gi, ":");
	strUrl = strUrl.replace(/\//gi, "\\");
	strUrl = unescape(strUrl);
	strUrl = strUrl.replace(/file:\\\\\\/gi, "");
	return strUrl;
}

function removeXolDummyWSMenu()
{
	var strConfPath = dreamweaver.getConfigurationPath();

	// Turn the URL into a DOS-style file/folder
	strConfPath = urlToPathname(strConfPath);

	XMMDwExJs.RemoveDreamweaverXolDummyWSMenu(strConfPath);
}

function showFloaters(bShow)
{
	// Find the state of the objects and properties floaters - if they are visible we will need to hide them...
	if (!bShow)
	{
		gbXMMShowObjectsFloater = dreamweaver.getFloaterVisibility("objects");
		gbXMMShowPropertiesFloater = dreamweaver.getFloaterVisibility("properties");
	}

	if (!bShow || gbXMMShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", bShow); }
	if (!bShow || gbXMMShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", bShow); }

	if (bShow) { gbXMMShowObjectsFloater = false; gbXMMShowPropertiesFloater = false; }
}

function MenuMakerRelativeToAbsoluteURL(imageSrc)
{
	// RelativeToAbsoluteUrl() seems to have changed function - you need to give it the path in DW3 and path+filename in DW4
	var bVersionThree = false;
	if (dw.appVersion)
	{
		var re = /^\d+/;
		var appversion = dw.appVersion.match(re);
		if (appversion && (appversion == 3)) { bVersionThree = true; }
	}

	var documentPath = bVersionThree ? getExportPath() : dreamweaver.getDocumentPath("document");

	// Convert it to an absolute path and remove web-specific mark-up so that the bitmap importer can't get confused!
	imageSrc = dw.relativeToAbsoluteURL(documentPath, dw.getSiteRoot(), imageSrc);

	// Remove characters that MenuMaker won't cope with too well...
	strConfPath = urlToPathname(strConfPath);

	return imageSrc;
}

function menuMakerGetImageDimensions(imageSrc)
{
	// Construct the return array and initialise it...
	var imageDimensions = new Array(2);
	imageDimensions[0] = 0; imageDimensions[1] = 0;
	
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return imageDimensions; }

	var selObj = docDOM.getSelectedNode();
	if (!selObj) { return imageDimensions; }

	if (!docDOM.images || (docDOM.images.length < 1)) { return imageDimensions; }

	var testString = "<img src=\"" + imageSrc + "\"";
	testString = unescape(testString.toLowerCase());
	
	var selDomImage = null;
	for (var nCounter=0; nCounter < docDOM.images.length; nCounter++)
	{
		var tempString = unescape(docDOM.images[nCounter].outerHTML).substr(0,testString.length).toLowerCase();
		if (testString == tempString)
		{
			selDomImage = docDOM.images[nCounter];
			break;
		}
	}

	// Make some variables to hold the width and height data...
	var docWidth = selObj.getAttribute("width");
	var docHeight = selObj.getAttribute("height");
	var bmpWidth = 0;
	var bmpHeight = 0;

	// If we found the correct image in the DOM's image list, then proceed...
	if (selDomImage)
	{
		// Get the image source as recorded in the DOM - this should be the absolute path used to locate the image...
		var imageSource = selDomImage.src;
		if (imageSource && !(docWidth && docHeight))
		{
			imageSource = MenuMakerRelativeToAbsoluteURL(imageSource);

			// ***** TEMPORARY: The BmpImpr.dll doesn't work with PNGs!!! *****
			if (imageSource.substr(imageSource.length-4, 4).toLowerCase() != ".png")
			{
				// Call into our JS DLL and get MenuMaker's bitmap importer to extract the image's dimensions...
				var result = XMMDwExJs.GetImageDimensions(imageSource);
				bmpWidth = result[0];
				bmpHeight = result[1];
			}
		}
	}

	// If we didn't know both values in the document, then we need to scale the other value by the one of the original file
	if ((bmpWidth != 0) && (bmpHeight != 0))
	{
		if (!docWidth && docHeight) { docWidth = Math.floor((bmpWidth/bmpHeight) * docHeight); }
		if (!docHeight && docWidth) { docHeight = Math.floor((bmpHeight/bmpWidth) * docWidth); }
	}

	var imageWidth = "";
	var imageHeight = "";
	if (docWidth) { imageWidth = docWidth; } else if (bmpWidth != 0) { imageWidth = bmpWidth; }
	if (docHeight) { imageHeight = docHeight; } else if (bmpHeight != 0) { imageHeight = bmpHeight; }
	
	imageDimensions[0] = imageWidth;
	imageDimensions[1] = imageHeight;
	
	return imageDimensions;
}